# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rc_pick_client/CellFillingLevel.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import rc_pick_client.msg

class CellFillingLevel(genpy.Message):
  _md5sum = "3a710ad528635ac53343c4ff1179252c"
  _type = "rc_pick_client/CellFillingLevel"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Dimensions of the 2D cell in meters
Rectangle cell_size

# Position of the cell center in meters (either in camera or external pose frame)
# The z-coordinate is on the level of the load carrier rim
geometry_msgs/Point cell_position

# Filling level of the cell in percent (100% represents a full cell)
RangeValue level_in_percent

# Free space of the cell in meters (how much space is left until the cell is full)
RangeValue level_free_in_meters

# Represents the percentage of valid pixels in this cell. Between 0 and 1 
float64 coverage

================================================================================
MSG: rc_pick_client/Rectangle
# Definition of a rectangle

float64 x
float64 y

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: rc_pick_client/RangeValue
float64 min
float64 max
float64 mean
"""
  __slots__ = ['cell_size','cell_position','level_in_percent','level_free_in_meters','coverage']
  _slot_types = ['rc_pick_client/Rectangle','geometry_msgs/Point','rc_pick_client/RangeValue','rc_pick_client/RangeValue','float64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       cell_size,cell_position,level_in_percent,level_free_in_meters,coverage

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(CellFillingLevel, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.cell_size is None:
        self.cell_size = rc_pick_client.msg.Rectangle()
      if self.cell_position is None:
        self.cell_position = geometry_msgs.msg.Point()
      if self.level_in_percent is None:
        self.level_in_percent = rc_pick_client.msg.RangeValue()
      if self.level_free_in_meters is None:
        self.level_free_in_meters = rc_pick_client.msg.RangeValue()
      if self.coverage is None:
        self.coverage = 0.
    else:
      self.cell_size = rc_pick_client.msg.Rectangle()
      self.cell_position = geometry_msgs.msg.Point()
      self.level_in_percent = rc_pick_client.msg.RangeValue()
      self.level_free_in_meters = rc_pick_client.msg.RangeValue()
      self.coverage = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_12d().pack(_x.cell_size.x, _x.cell_size.y, _x.cell_position.x, _x.cell_position.y, _x.cell_position.z, _x.level_in_percent.min, _x.level_in_percent.max, _x.level_in_percent.mean, _x.level_free_in_meters.min, _x.level_free_in_meters.max, _x.level_free_in_meters.mean, _x.coverage))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.cell_size is None:
        self.cell_size = rc_pick_client.msg.Rectangle()
      if self.cell_position is None:
        self.cell_position = geometry_msgs.msg.Point()
      if self.level_in_percent is None:
        self.level_in_percent = rc_pick_client.msg.RangeValue()
      if self.level_free_in_meters is None:
        self.level_free_in_meters = rc_pick_client.msg.RangeValue()
      end = 0
      _x = self
      start = end
      end += 96
      (_x.cell_size.x, _x.cell_size.y, _x.cell_position.x, _x.cell_position.y, _x.cell_position.z, _x.level_in_percent.min, _x.level_in_percent.max, _x.level_in_percent.mean, _x.level_free_in_meters.min, _x.level_free_in_meters.max, _x.level_free_in_meters.mean, _x.coverage,) = _get_struct_12d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_12d().pack(_x.cell_size.x, _x.cell_size.y, _x.cell_position.x, _x.cell_position.y, _x.cell_position.z, _x.level_in_percent.min, _x.level_in_percent.max, _x.level_in_percent.mean, _x.level_free_in_meters.min, _x.level_free_in_meters.max, _x.level_free_in_meters.mean, _x.coverage))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.cell_size is None:
        self.cell_size = rc_pick_client.msg.Rectangle()
      if self.cell_position is None:
        self.cell_position = geometry_msgs.msg.Point()
      if self.level_in_percent is None:
        self.level_in_percent = rc_pick_client.msg.RangeValue()
      if self.level_free_in_meters is None:
        self.level_free_in_meters = rc_pick_client.msg.RangeValue()
      end = 0
      _x = self
      start = end
      end += 96
      (_x.cell_size.x, _x.cell_size.y, _x.cell_position.x, _x.cell_position.y, _x.cell_position.z, _x.level_in_percent.min, _x.level_in_percent.max, _x.level_in_percent.mean, _x.level_free_in_meters.min, _x.level_free_in_meters.max, _x.level_free_in_meters.mean, _x.coverage,) = _get_struct_12d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_12d = None
def _get_struct_12d():
    global _struct_12d
    if _struct_12d is None:
        _struct_12d = struct.Struct("<12d")
    return _struct_12d
