# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rc_pick_client/ComputeGraspsRequest.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import rc_pick_client.msg

class ComputeGraspsRequest(genpy.Message):
  _md5sum = "fa640774f984fc6944b698c3211fbfaa"
  _type = "rc_pick_client/ComputeGraspsRequest"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """


string pose_frame


string region_of_interest_id


string load_carrier_id


Compartment load_carrier_compartment


ItemModel[] item_models




float64 suction_surface_length
float64 suction_surface_width


geometry_msgs/Pose robot_pose


CollisionDetection collision_detection


================================================================================
MSG: rc_pick_client/Compartment
# Definition of a load carrier compartment

# The pose of the compartment is relative to the load carrier
geometry_msgs/Pose pose

# Size of the compartment
Box box

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: rc_pick_client/Box
# Definition of a box

float64 x
float64 y
float64 z

================================================================================
MSG: rc_pick_client/ItemModel
# Definition of an item model for the ItemPick and BoxPick components

# Required
string type

# Supported types (depending on component)
string UNKNOWN=UNKNOWN
string RECTANGLE=RECTANGLE

# Only one of those required depending on the selected type
# In case of unknown type, these values defines an optional bounding box for the item
RangeBox unknown
RangeRectangle rectangle

================================================================================
MSG: rc_pick_client/RangeBox
# Definition of a box with minimum and maximum dimensions

Box min_dimensions
Box max_dimensions

================================================================================
MSG: rc_pick_client/RangeRectangle
# Definition of a rectangle with minimum and maximum dimensions

Rectangle min_dimensions
Rectangle max_dimensions

================================================================================
MSG: rc_pick_client/Rectangle
# Definition of a rectangle

float64 x
float64 y

================================================================================
MSG: rc_pick_client/CollisionDetection
string gripper_id

geometry_msgs/Point pre_grasp_offset
"""
  __slots__ = ['pose_frame','region_of_interest_id','load_carrier_id','load_carrier_compartment','item_models','suction_surface_length','suction_surface_width','robot_pose','collision_detection']
  _slot_types = ['string','string','string','rc_pick_client/Compartment','rc_pick_client/ItemModel[]','float64','float64','geometry_msgs/Pose','rc_pick_client/CollisionDetection']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       pose_frame,region_of_interest_id,load_carrier_id,load_carrier_compartment,item_models,suction_surface_length,suction_surface_width,robot_pose,collision_detection

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ComputeGraspsRequest, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.pose_frame is None:
        self.pose_frame = ''
      if self.region_of_interest_id is None:
        self.region_of_interest_id = ''
      if self.load_carrier_id is None:
        self.load_carrier_id = ''
      if self.load_carrier_compartment is None:
        self.load_carrier_compartment = rc_pick_client.msg.Compartment()
      if self.item_models is None:
        self.item_models = []
      if self.suction_surface_length is None:
        self.suction_surface_length = 0.
      if self.suction_surface_width is None:
        self.suction_surface_width = 0.
      if self.robot_pose is None:
        self.robot_pose = geometry_msgs.msg.Pose()
      if self.collision_detection is None:
        self.collision_detection = rc_pick_client.msg.CollisionDetection()
    else:
      self.pose_frame = ''
      self.region_of_interest_id = ''
      self.load_carrier_id = ''
      self.load_carrier_compartment = rc_pick_client.msg.Compartment()
      self.item_models = []
      self.suction_surface_length = 0.
      self.suction_surface_width = 0.
      self.robot_pose = geometry_msgs.msg.Pose()
      self.collision_detection = rc_pick_client.msg.CollisionDetection()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.pose_frame
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.region_of_interest_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.load_carrier_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_10d().pack(_x.load_carrier_compartment.pose.position.x, _x.load_carrier_compartment.pose.position.y, _x.load_carrier_compartment.pose.position.z, _x.load_carrier_compartment.pose.orientation.x, _x.load_carrier_compartment.pose.orientation.y, _x.load_carrier_compartment.pose.orientation.z, _x.load_carrier_compartment.pose.orientation.w, _x.load_carrier_compartment.box.x, _x.load_carrier_compartment.box.y, _x.load_carrier_compartment.box.z))
      length = len(self.item_models)
      buff.write(_struct_I.pack(length))
      for val1 in self.item_models:
        _x = val1.type
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v1 = val1.unknown
        _v2 = _v1.min_dimensions
        _x = _v2
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v3 = _v1.max_dimensions
        _x = _v3
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v4 = val1.rectangle
        _v5 = _v4.min_dimensions
        _x = _v5
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
        _v6 = _v4.max_dimensions
        _x = _v6
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
      _x = self
      buff.write(_get_struct_9d().pack(_x.suction_surface_length, _x.suction_surface_width, _x.robot_pose.position.x, _x.robot_pose.position.y, _x.robot_pose.position.z, _x.robot_pose.orientation.x, _x.robot_pose.orientation.y, _x.robot_pose.orientation.z, _x.robot_pose.orientation.w))
      _x = self.collision_detection.gripper_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3d().pack(_x.collision_detection.pre_grasp_offset.x, _x.collision_detection.pre_grasp_offset.y, _x.collision_detection.pre_grasp_offset.z))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.load_carrier_compartment is None:
        self.load_carrier_compartment = rc_pick_client.msg.Compartment()
      if self.item_models is None:
        self.item_models = None
      if self.robot_pose is None:
        self.robot_pose = geometry_msgs.msg.Pose()
      if self.collision_detection is None:
        self.collision_detection = rc_pick_client.msg.CollisionDetection()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.pose_frame = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.pose_frame = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.region_of_interest_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.region_of_interest_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.load_carrier_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.load_carrier_id = str[start:end]
      _x = self
      start = end
      end += 80
      (_x.load_carrier_compartment.pose.position.x, _x.load_carrier_compartment.pose.position.y, _x.load_carrier_compartment.pose.position.z, _x.load_carrier_compartment.pose.orientation.x, _x.load_carrier_compartment.pose.orientation.y, _x.load_carrier_compartment.pose.orientation.z, _x.load_carrier_compartment.pose.orientation.w, _x.load_carrier_compartment.box.x, _x.load_carrier_compartment.box.y, _x.load_carrier_compartment.box.z,) = _get_struct_10d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.item_models = []
      for i in range(0, length):
        val1 = rc_pick_client.msg.ItemModel()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.type = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.type = str[start:end]
        _v7 = val1.unknown
        _v8 = _v7.min_dimensions
        _x = _v8
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v9 = _v7.max_dimensions
        _x = _v9
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v10 = val1.rectangle
        _v11 = _v10.min_dimensions
        _x = _v11
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        _v12 = _v10.max_dimensions
        _x = _v12
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        self.item_models.append(val1)
      _x = self
      start = end
      end += 72
      (_x.suction_surface_length, _x.suction_surface_width, _x.robot_pose.position.x, _x.robot_pose.position.y, _x.robot_pose.position.z, _x.robot_pose.orientation.x, _x.robot_pose.orientation.y, _x.robot_pose.orientation.z, _x.robot_pose.orientation.w,) = _get_struct_9d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.collision_detection.gripper_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.collision_detection.gripper_id = str[start:end]
      _x = self
      start = end
      end += 24
      (_x.collision_detection.pre_grasp_offset.x, _x.collision_detection.pre_grasp_offset.y, _x.collision_detection.pre_grasp_offset.z,) = _get_struct_3d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.pose_frame
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.region_of_interest_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.load_carrier_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_10d().pack(_x.load_carrier_compartment.pose.position.x, _x.load_carrier_compartment.pose.position.y, _x.load_carrier_compartment.pose.position.z, _x.load_carrier_compartment.pose.orientation.x, _x.load_carrier_compartment.pose.orientation.y, _x.load_carrier_compartment.pose.orientation.z, _x.load_carrier_compartment.pose.orientation.w, _x.load_carrier_compartment.box.x, _x.load_carrier_compartment.box.y, _x.load_carrier_compartment.box.z))
      length = len(self.item_models)
      buff.write(_struct_I.pack(length))
      for val1 in self.item_models:
        _x = val1.type
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v13 = val1.unknown
        _v14 = _v13.min_dimensions
        _x = _v14
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v15 = _v13.max_dimensions
        _x = _v15
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v16 = val1.rectangle
        _v17 = _v16.min_dimensions
        _x = _v17
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
        _v18 = _v16.max_dimensions
        _x = _v18
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
      _x = self
      buff.write(_get_struct_9d().pack(_x.suction_surface_length, _x.suction_surface_width, _x.robot_pose.position.x, _x.robot_pose.position.y, _x.robot_pose.position.z, _x.robot_pose.orientation.x, _x.robot_pose.orientation.y, _x.robot_pose.orientation.z, _x.robot_pose.orientation.w))
      _x = self.collision_detection.gripper_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3d().pack(_x.collision_detection.pre_grasp_offset.x, _x.collision_detection.pre_grasp_offset.y, _x.collision_detection.pre_grasp_offset.z))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.load_carrier_compartment is None:
        self.load_carrier_compartment = rc_pick_client.msg.Compartment()
      if self.item_models is None:
        self.item_models = None
      if self.robot_pose is None:
        self.robot_pose = geometry_msgs.msg.Pose()
      if self.collision_detection is None:
        self.collision_detection = rc_pick_client.msg.CollisionDetection()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.pose_frame = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.pose_frame = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.region_of_interest_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.region_of_interest_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.load_carrier_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.load_carrier_id = str[start:end]
      _x = self
      start = end
      end += 80
      (_x.load_carrier_compartment.pose.position.x, _x.load_carrier_compartment.pose.position.y, _x.load_carrier_compartment.pose.position.z, _x.load_carrier_compartment.pose.orientation.x, _x.load_carrier_compartment.pose.orientation.y, _x.load_carrier_compartment.pose.orientation.z, _x.load_carrier_compartment.pose.orientation.w, _x.load_carrier_compartment.box.x, _x.load_carrier_compartment.box.y, _x.load_carrier_compartment.box.z,) = _get_struct_10d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.item_models = []
      for i in range(0, length):
        val1 = rc_pick_client.msg.ItemModel()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.type = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.type = str[start:end]
        _v19 = val1.unknown
        _v20 = _v19.min_dimensions
        _x = _v20
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v21 = _v19.max_dimensions
        _x = _v21
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v22 = val1.rectangle
        _v23 = _v22.min_dimensions
        _x = _v23
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        _v24 = _v22.max_dimensions
        _x = _v24
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        self.item_models.append(val1)
      _x = self
      start = end
      end += 72
      (_x.suction_surface_length, _x.suction_surface_width, _x.robot_pose.position.x, _x.robot_pose.position.y, _x.robot_pose.position.z, _x.robot_pose.orientation.x, _x.robot_pose.orientation.y, _x.robot_pose.orientation.z, _x.robot_pose.orientation.w,) = _get_struct_9d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.collision_detection.gripper_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.collision_detection.gripper_id = str[start:end]
      _x = self
      start = end
      end += 24
      (_x.collision_detection.pre_grasp_offset.x, _x.collision_detection.pre_grasp_offset.y, _x.collision_detection.pre_grasp_offset.z,) = _get_struct_3d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_10d = None
def _get_struct_10d():
    global _struct_10d
    if _struct_10d is None:
        _struct_10d = struct.Struct("<10d")
    return _struct_10d
_struct_2d = None
def _get_struct_2d():
    global _struct_2d
    if _struct_2d is None:
        _struct_2d = struct.Struct("<2d")
    return _struct_2d
_struct_3d = None
def _get_struct_3d():
    global _struct_3d
    if _struct_3d is None:
        _struct_3d = struct.Struct("<3d")
    return _struct_3d
_struct_9d = None
def _get_struct_9d():
    global _struct_9d
    if _struct_9d is None:
        _struct_9d = struct.Struct("<9d")
    return _struct_9d
# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rc_pick_client/ComputeGraspsResponse.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy
import geometry_msgs.msg
import rc_common_msgs.msg
import rc_pick_client.msg
import std_msgs.msg

class ComputeGraspsResponse(genpy.Message):
  _md5sum = "d41e265cd30fce9d910971bbaa4e438a"
  _type = "rc_pick_client/ComputeGraspsResponse"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """
time timestamp

LoadCarrier[] load_carriers

SuctionGrasp[] grasps

rc_common_msgs/ReturnCode return_code


================================================================================
MSG: rc_pick_client/LoadCarrier
# This represents a load carrier by its geometry and its pose

string id

# Required
Box outer_dimensions

# Required
Box inner_dimensions

# Optional. If not provided, the rim thickness is computed from the outer and inner dimensions
Rectangle rim_thickness

geometry_msgs/PoseStamped pose

# True if a detected load carrier is overfilled. Ignored on setting load carrier.
bool overfilled

================================================================================
MSG: rc_pick_client/Box
# Definition of a box

float64 x
float64 y
float64 z

================================================================================
MSG: rc_pick_client/Rectangle
# Definition of a rectangle

float64 x
float64 y

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: rc_pick_client/SuctionGrasp
# Definition of a suction grasp for the itempick component

string uuid

# Optional
string item_uuid

# The grasp orientation is defined such that:
# - the z axis is the normal of the surface at the grasp position
# - the x axis is directed along the direction of maximum elongation of the surface
# - the y axis is selected to form a right-handed coordinate system
geometry_msgs/PoseStamped pose

# Optional. The quality of the grasp (between 0 and 1)
float64 quality

# Optional. The axis lengths of the biggest ellipse inscribed on the suction surface
float64 max_suction_surface_length
float64 max_suction_surface_width

================================================================================
MSG: rc_common_msgs/ReturnCode
# This message shall be used in the response of services as a field called return_code.
# Confer to ReturnCodeConsts message for commonly used return code definitions.

# return codes
# >=0 - success
# < 0 - failure

# return code
int16 value

# return message
string message
"""
  __slots__ = ['timestamp','load_carriers','grasps','return_code']
  _slot_types = ['time','rc_pick_client/LoadCarrier[]','rc_pick_client/SuctionGrasp[]','rc_common_msgs/ReturnCode']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,load_carriers,grasps,return_code

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ComputeGraspsResponse, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      if self.load_carriers is None:
        self.load_carriers = []
      if self.grasps is None:
        self.grasps = []
      if self.return_code is None:
        self.return_code = rc_common_msgs.msg.ReturnCode()
    else:
      self.timestamp = genpy.Time()
      self.load_carriers = []
      self.grasps = []
      self.return_code = rc_common_msgs.msg.ReturnCode()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2I().pack(_x.timestamp.secs, _x.timestamp.nsecs))
      length = len(self.load_carriers)
      buff.write(_struct_I.pack(length))
      for val1 in self.load_carriers:
        _x = val1.id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v25 = val1.outer_dimensions
        _x = _v25
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v26 = val1.inner_dimensions
        _x = _v26
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v27 = val1.rim_thickness
        _x = _v27
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
        _v28 = val1.pose
        _v29 = _v28.header
        _x = _v29.seq
        buff.write(_get_struct_I().pack(_x))
        _v30 = _v29.stamp
        _x = _v30
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = _v29.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v31 = _v28.pose
        _v32 = _v31.position
        _x = _v32
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v33 = _v31.orientation
        _x = _v33
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1.overfilled
        buff.write(_get_struct_B().pack(_x))
      length = len(self.grasps)
      buff.write(_struct_I.pack(length))
      for val1 in self.grasps:
        _x = val1.uuid
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.item_uuid
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v34 = val1.pose
        _v35 = _v34.header
        _x = _v35.seq
        buff.write(_get_struct_I().pack(_x))
        _v36 = _v35.stamp
        _x = _v36
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = _v35.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v37 = _v34.pose
        _v38 = _v37.position
        _x = _v38
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v39 = _v37.orientation
        _x = _v39
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1
        buff.write(_get_struct_3d().pack(_x.quality, _x.max_suction_surface_length, _x.max_suction_surface_width))
      _x = self.return_code.value
      buff.write(_get_struct_h().pack(_x))
      _x = self.return_code.message
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      if self.load_carriers is None:
        self.load_carriers = None
      if self.grasps is None:
        self.grasps = None
      if self.return_code is None:
        self.return_code = rc_common_msgs.msg.ReturnCode()
      end = 0
      _x = self
      start = end
      end += 8
      (_x.timestamp.secs, _x.timestamp.nsecs,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.load_carriers = []
      for i in range(0, length):
        val1 = rc_pick_client.msg.LoadCarrier()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.id = str[start:end]
        _v40 = val1.outer_dimensions
        _x = _v40
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v41 = val1.inner_dimensions
        _x = _v41
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v42 = val1.rim_thickness
        _x = _v42
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        _v43 = val1.pose
        _v44 = _v43.header
        start = end
        end += 4
        (_v44.seq,) = _get_struct_I().unpack(str[start:end])
        _v45 = _v44.stamp
        _x = _v45
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v44.frame_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v44.frame_id = str[start:end]
        _v46 = _v43.pose
        _v47 = _v46.position
        _x = _v47
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v48 = _v46.orientation
        _x = _v48
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        start = end
        end += 1
        (val1.overfilled,) = _get_struct_B().unpack(str[start:end])
        val1.overfilled = bool(val1.overfilled)
        self.load_carriers.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.grasps = []
      for i in range(0, length):
        val1 = rc_pick_client.msg.SuctionGrasp()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.uuid = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.uuid = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.item_uuid = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.item_uuid = str[start:end]
        _v49 = val1.pose
        _v50 = _v49.header
        start = end
        end += 4
        (_v50.seq,) = _get_struct_I().unpack(str[start:end])
        _v51 = _v50.stamp
        _x = _v51
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v50.frame_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v50.frame_id = str[start:end]
        _v52 = _v49.pose
        _v53 = _v52.position
        _x = _v53
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v54 = _v52.orientation
        _x = _v54
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        _x = val1
        start = end
        end += 24
        (_x.quality, _x.max_suction_surface_length, _x.max_suction_surface_width,) = _get_struct_3d().unpack(str[start:end])
        self.grasps.append(val1)
      start = end
      end += 2
      (self.return_code.value,) = _get_struct_h().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.return_code.message = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.return_code.message = str[start:end]
      self.timestamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2I().pack(_x.timestamp.secs, _x.timestamp.nsecs))
      length = len(self.load_carriers)
      buff.write(_struct_I.pack(length))
      for val1 in self.load_carriers:
        _x = val1.id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v55 = val1.outer_dimensions
        _x = _v55
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v56 = val1.inner_dimensions
        _x = _v56
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v57 = val1.rim_thickness
        _x = _v57
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
        _v58 = val1.pose
        _v59 = _v58.header
        _x = _v59.seq
        buff.write(_get_struct_I().pack(_x))
        _v60 = _v59.stamp
        _x = _v60
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = _v59.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v61 = _v58.pose
        _v62 = _v61.position
        _x = _v62
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v63 = _v61.orientation
        _x = _v63
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1.overfilled
        buff.write(_get_struct_B().pack(_x))
      length = len(self.grasps)
      buff.write(_struct_I.pack(length))
      for val1 in self.grasps:
        _x = val1.uuid
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.item_uuid
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v64 = val1.pose
        _v65 = _v64.header
        _x = _v65.seq
        buff.write(_get_struct_I().pack(_x))
        _v66 = _v65.stamp
        _x = _v66
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = _v65.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v67 = _v64.pose
        _v68 = _v67.position
        _x = _v68
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v69 = _v67.orientation
        _x = _v69
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1
        buff.write(_get_struct_3d().pack(_x.quality, _x.max_suction_surface_length, _x.max_suction_surface_width))
      _x = self.return_code.value
      buff.write(_get_struct_h().pack(_x))
      _x = self.return_code.message
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      if self.load_carriers is None:
        self.load_carriers = None
      if self.grasps is None:
        self.grasps = None
      if self.return_code is None:
        self.return_code = rc_common_msgs.msg.ReturnCode()
      end = 0
      _x = self
      start = end
      end += 8
      (_x.timestamp.secs, _x.timestamp.nsecs,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.load_carriers = []
      for i in range(0, length):
        val1 = rc_pick_client.msg.LoadCarrier()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.id = str[start:end]
        _v70 = val1.outer_dimensions
        _x = _v70
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v71 = val1.inner_dimensions
        _x = _v71
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v72 = val1.rim_thickness
        _x = _v72
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        _v73 = val1.pose
        _v74 = _v73.header
        start = end
        end += 4
        (_v74.seq,) = _get_struct_I().unpack(str[start:end])
        _v75 = _v74.stamp
        _x = _v75
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v74.frame_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v74.frame_id = str[start:end]
        _v76 = _v73.pose
        _v77 = _v76.position
        _x = _v77
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v78 = _v76.orientation
        _x = _v78
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        start = end
        end += 1
        (val1.overfilled,) = _get_struct_B().unpack(str[start:end])
        val1.overfilled = bool(val1.overfilled)
        self.load_carriers.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.grasps = []
      for i in range(0, length):
        val1 = rc_pick_client.msg.SuctionGrasp()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.uuid = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.uuid = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.item_uuid = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.item_uuid = str[start:end]
        _v79 = val1.pose
        _v80 = _v79.header
        start = end
        end += 4
        (_v80.seq,) = _get_struct_I().unpack(str[start:end])
        _v81 = _v80.stamp
        _x = _v81
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v80.frame_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v80.frame_id = str[start:end]
        _v82 = _v79.pose
        _v83 = _v82.position
        _x = _v83
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v84 = _v82.orientation
        _x = _v84
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        _x = val1
        start = end
        end += 24
        (_x.quality, _x.max_suction_surface_length, _x.max_suction_surface_width,) = _get_struct_3d().unpack(str[start:end])
        self.grasps.append(val1)
      start = end
      end += 2
      (self.return_code.value,) = _get_struct_h().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.return_code.message = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.return_code.message = str[start:end]
      self.timestamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2I = None
def _get_struct_2I():
    global _struct_2I
    if _struct_2I is None:
        _struct_2I = struct.Struct("<2I")
    return _struct_2I
_struct_2d = None
def _get_struct_2d():
    global _struct_2d
    if _struct_2d is None:
        _struct_2d = struct.Struct("<2d")
    return _struct_2d
_struct_3d = None
def _get_struct_3d():
    global _struct_3d
    if _struct_3d is None:
        _struct_3d = struct.Struct("<3d")
    return _struct_3d
_struct_4d = None
def _get_struct_4d():
    global _struct_4d
    if _struct_4d is None:
        _struct_4d = struct.Struct("<4d")
    return _struct_4d
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_h = None
def _get_struct_h():
    global _struct_h
    if _struct_h is None:
        _struct_h = struct.Struct("<h")
    return _struct_h
class ComputeGrasps(object):
  _type          = 'rc_pick_client/ComputeGrasps'
  _md5sum = 'a96dc97459babad42db7da7db041ea6b'
  _request_class  = ComputeGraspsRequest
  _response_class = ComputeGraspsResponse
