// Auto-generated. Do not edit!

// (in-package rc_pick_client.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let Rectangle = require('./Rectangle.js');
let RangeValue = require('./RangeValue.js');
let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------

class CellFillingLevel {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.cell_size = null;
      this.cell_position = null;
      this.level_in_percent = null;
      this.level_free_in_meters = null;
      this.coverage = null;
    }
    else {
      if (initObj.hasOwnProperty('cell_size')) {
        this.cell_size = initObj.cell_size
      }
      else {
        this.cell_size = new Rectangle();
      }
      if (initObj.hasOwnProperty('cell_position')) {
        this.cell_position = initObj.cell_position
      }
      else {
        this.cell_position = new geometry_msgs.msg.Point();
      }
      if (initObj.hasOwnProperty('level_in_percent')) {
        this.level_in_percent = initObj.level_in_percent
      }
      else {
        this.level_in_percent = new RangeValue();
      }
      if (initObj.hasOwnProperty('level_free_in_meters')) {
        this.level_free_in_meters = initObj.level_free_in_meters
      }
      else {
        this.level_free_in_meters = new RangeValue();
      }
      if (initObj.hasOwnProperty('coverage')) {
        this.coverage = initObj.coverage
      }
      else {
        this.coverage = 0.0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type CellFillingLevel
    // Serialize message field [cell_size]
    bufferOffset = Rectangle.serialize(obj.cell_size, buffer, bufferOffset);
    // Serialize message field [cell_position]
    bufferOffset = geometry_msgs.msg.Point.serialize(obj.cell_position, buffer, bufferOffset);
    // Serialize message field [level_in_percent]
    bufferOffset = RangeValue.serialize(obj.level_in_percent, buffer, bufferOffset);
    // Serialize message field [level_free_in_meters]
    bufferOffset = RangeValue.serialize(obj.level_free_in_meters, buffer, bufferOffset);
    // Serialize message field [coverage]
    bufferOffset = _serializer.float64(obj.coverage, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type CellFillingLevel
    let len;
    let data = new CellFillingLevel(null);
    // Deserialize message field [cell_size]
    data.cell_size = Rectangle.deserialize(buffer, bufferOffset);
    // Deserialize message field [cell_position]
    data.cell_position = geometry_msgs.msg.Point.deserialize(buffer, bufferOffset);
    // Deserialize message field [level_in_percent]
    data.level_in_percent = RangeValue.deserialize(buffer, bufferOffset);
    // Deserialize message field [level_free_in_meters]
    data.level_free_in_meters = RangeValue.deserialize(buffer, bufferOffset);
    // Deserialize message field [coverage]
    data.coverage = _deserializer.float64(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 96;
  }

  static datatype() {
    // Returns string type for a message object
    return 'rc_pick_client/CellFillingLevel';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '3a710ad528635ac53343c4ff1179252c';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Dimensions of the 2D cell in meters
    Rectangle cell_size
    
    # Position of the cell center in meters (either in camera or external pose frame)
    # The z-coordinate is on the level of the load carrier rim
    geometry_msgs/Point cell_position
    
    # Filling level of the cell in percent (100% represents a full cell)
    RangeValue level_in_percent
    
    # Free space of the cell in meters (how much space is left until the cell is full)
    RangeValue level_free_in_meters
    
    # Represents the percentage of valid pixels in this cell. Between 0 and 1 
    float64 coverage
    
    ================================================================================
    MSG: rc_pick_client/Rectangle
    # Definition of a rectangle
    
    float64 x
    float64 y
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: rc_pick_client/RangeValue
    float64 min
    float64 max
    float64 mean
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new CellFillingLevel(null);
    if (msg.cell_size !== undefined) {
      resolved.cell_size = Rectangle.Resolve(msg.cell_size)
    }
    else {
      resolved.cell_size = new Rectangle()
    }

    if (msg.cell_position !== undefined) {
      resolved.cell_position = geometry_msgs.msg.Point.Resolve(msg.cell_position)
    }
    else {
      resolved.cell_position = new geometry_msgs.msg.Point()
    }

    if (msg.level_in_percent !== undefined) {
      resolved.level_in_percent = RangeValue.Resolve(msg.level_in_percent)
    }
    else {
      resolved.level_in_percent = new RangeValue()
    }

    if (msg.level_free_in_meters !== undefined) {
      resolved.level_free_in_meters = RangeValue.Resolve(msg.level_free_in_meters)
    }
    else {
      resolved.level_free_in_meters = new RangeValue()
    }

    if (msg.coverage !== undefined) {
      resolved.coverage = msg.coverage;
    }
    else {
      resolved.coverage = 0.0
    }

    return resolved;
    }
};

module.exports = CellFillingLevel;
