// Auto-generated. Do not edit!

// (in-package rc_pick_client.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let RegionOfInterest = require('../msg/RegionOfInterest.js');
let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------

let rc_common_msgs = _finder('rc_common_msgs');

//-----------------------------------------------------------

class SetRegionOfInterestRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.region_of_interest = null;
      this.robot_pose = null;
    }
    else {
      if (initObj.hasOwnProperty('region_of_interest')) {
        this.region_of_interest = initObj.region_of_interest
      }
      else {
        this.region_of_interest = new RegionOfInterest();
      }
      if (initObj.hasOwnProperty('robot_pose')) {
        this.robot_pose = initObj.robot_pose
      }
      else {
        this.robot_pose = new geometry_msgs.msg.Pose();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type SetRegionOfInterestRequest
    // Serialize message field [region_of_interest]
    bufferOffset = RegionOfInterest.serialize(obj.region_of_interest, buffer, bufferOffset);
    // Serialize message field [robot_pose]
    bufferOffset = geometry_msgs.msg.Pose.serialize(obj.robot_pose, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type SetRegionOfInterestRequest
    let len;
    let data = new SetRegionOfInterestRequest(null);
    // Deserialize message field [region_of_interest]
    data.region_of_interest = RegionOfInterest.deserialize(buffer, bufferOffset);
    // Deserialize message field [robot_pose]
    data.robot_pose = geometry_msgs.msg.Pose.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += RegionOfInterest.getMessageSize(object.region_of_interest);
    return length + 56;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rc_pick_client/SetRegionOfInterestRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '5eb1edf669789481f47db84a01a126e6';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    
    
    
    RegionOfInterest region_of_interest
    
    
    geometry_msgs/Pose robot_pose
    
    
    ================================================================================
    MSG: rc_pick_client/RegionOfInterest
    # Definition of a region of interest (Primitive type with id)
    
    # Optional
    string id
    
    # Required
    geometry_msgs/PoseStamped pose
    
    shape_msgs/SolidPrimitive primitive
    
    ================================================================================
    MSG: geometry_msgs/PoseStamped
    # A Pose with reference coordinate frame and timestamp
    Header header
    Pose pose
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    # 0: no frame
    # 1: global frame
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    ================================================================================
    MSG: shape_msgs/SolidPrimitive
    # Define box, sphere, cylinder, cone 
    # All shapes are defined to have their bounding boxes centered around 0,0,0.
    
    uint8 BOX=1
    uint8 SPHERE=2
    uint8 CYLINDER=3
    uint8 CONE=4
    
    # The type of the shape
    uint8 type
    
    
    # The dimensions of the shape
    float64[] dimensions
    
    # The meaning of the shape dimensions: each constant defines the index in the 'dimensions' array
    
    # For the BOX type, the X, Y, and Z dimensions are the length of the corresponding
    # sides of the box.
    uint8 BOX_X=0
    uint8 BOX_Y=1
    uint8 BOX_Z=2
    
    
    # For the SPHERE type, only one component is used, and it gives the radius of
    # the sphere.
    uint8 SPHERE_RADIUS=0
    
    
    # For the CYLINDER and CONE types, the center line is oriented along
    # the Z axis.  Therefore the CYLINDER_HEIGHT (CONE_HEIGHT) component
    # of dimensions gives the height of the cylinder (cone).  The
    # CYLINDER_RADIUS (CONE_RADIUS) component of dimensions gives the
    # radius of the base of the cylinder (cone).  Cone and cylinder
    # primitives are defined to be circular. The tip of the cone is
    # pointing up, along +Z axis.
    
    uint8 CYLINDER_HEIGHT=0
    uint8 CYLINDER_RADIUS=1
    
    uint8 CONE_HEIGHT=0
    uint8 CONE_RADIUS=1
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new SetRegionOfInterestRequest(null);
    if (msg.region_of_interest !== undefined) {
      resolved.region_of_interest = RegionOfInterest.Resolve(msg.region_of_interest)
    }
    else {
      resolved.region_of_interest = new RegionOfInterest()
    }

    if (msg.robot_pose !== undefined) {
      resolved.robot_pose = geometry_msgs.msg.Pose.Resolve(msg.robot_pose)
    }
    else {
      resolved.robot_pose = new geometry_msgs.msg.Pose()
    }

    return resolved;
    }
};

class SetRegionOfInterestResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.return_code = null;
    }
    else {
      if (initObj.hasOwnProperty('return_code')) {
        this.return_code = initObj.return_code
      }
      else {
        this.return_code = new rc_common_msgs.msg.ReturnCode();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type SetRegionOfInterestResponse
    // Serialize message field [return_code]
    bufferOffset = rc_common_msgs.msg.ReturnCode.serialize(obj.return_code, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type SetRegionOfInterestResponse
    let len;
    let data = new SetRegionOfInterestResponse(null);
    // Deserialize message field [return_code]
    data.return_code = rc_common_msgs.msg.ReturnCode.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += rc_common_msgs.msg.ReturnCode.getMessageSize(object.return_code);
    return length;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rc_pick_client/SetRegionOfInterestResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '89940768eec602f7650f8f061383e0f9';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    
    rc_common_msgs/ReturnCode return_code
    
    
    ================================================================================
    MSG: rc_common_msgs/ReturnCode
    # This message shall be used in the response of services as a field called return_code.
    # Confer to ReturnCodeConsts message for commonly used return code definitions.
    
    # return codes
    # >=0 - success
    # < 0 - failure
    
    # return code
    int16 value
    
    # return message
    string message
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new SetRegionOfInterestResponse(null);
    if (msg.return_code !== undefined) {
      resolved.return_code = rc_common_msgs.msg.ReturnCode.Resolve(msg.return_code)
    }
    else {
      resolved.return_code = new rc_common_msgs.msg.ReturnCode()
    }

    return resolved;
    }
};

module.exports = {
  Request: SetRegionOfInterestRequest,
  Response: SetRegionOfInterestResponse,
  md5sum() { return '367e6a000b0a54567e2ca218ebd51d9b'; },
  datatype() { return 'rc_pick_client/SetRegionOfInterest'; }
};
